#include "CHighscore.h"

/********************************\
*  Konstrukturen und Destruktur  *
\********************************/
CHighscore::CHighscore(string name, string filename, int anzahl)
{
	// Name der Highscoreliste
	scorename = name;

	// Liste erzeugen mit der anzahl
	liste_erzeugen(anzahl);

	dateiname = filename;

	// Liste mit Daten fllen und sortieren
	daten_einlesen();
	sortieren();
}

CHighscore::~CHighscore()
{
	// daten_speichern
	daten_speichern();

	// Speicher der Liste wieder frei geben
	if (list>0)
	{
		delete [] list;
		list = 0;
	}
}

/*******************************************************************\
*  Private Funktionen zum erzeugen, fllen und sortieren der Liste  *
\*******************************************************************/
void CHighscore::sortieren()
{
	strList tmp;
	int max, newpos;
	short i,j;

	for (i=0;i<anzahl;i++)
	{
		max = list[i].punkte;
		newpos = i;
		for (j=i;j<anzahl;j++)
		{
			if (max < list[j].punkte)
			{
				max = list[j].punkte;
				newpos = j;
			}
		}

		// tauschen
		if (newpos>i)
		{
			tmp = list[i];
			list[i] = list[newpos];
			list[newpos] = tmp;
		}
	}
}

void CHighscore::liste_erzeugen(int anz)
{
	// Lnge der Liste an Klassenvariable bergeben
	anzahl=anz;

	// Speicher fr Liste Reservieren
	list = 0;
	list = new strList[anzahl];
	if (list==0)
	{
		cout << "\nKonnte keine Liste erzeugen!\nSpeicherallocation nicht mglich\n";
		exit(1);
	}
}

void CHighscore::daten_einlesen()
{
	// Daten einlesen
	short i=0, pos=-1;
	string zeile,tmp;

	ifstream in(dateiname.c_str());

	if (in.good())		// ist die datei vorhanden, daten einlesen
	{
		while( (!in.eof()) || (i<anzahl) )
		{
			// wenn die datei mehr Datenstze enthllt als erwartet -> abbruch
			if (i==anzahl) break;

			// zeile aus Datei einlesen
			getline(in,zeile);

			// Daten aus der zeile auslesen
			pos = zeile.find(";");
			if (pos>=0)		// berprft ob es ein zulssiger String ist
			{
				tmp=zeile;
				zeile.erase(pos);	// alles ab ; lschen
				tmp.erase(0,pos+1);		// alles bis ; lschen

				// Daten in den Datensatz bernehmen
				list[i].name=zeile;
				list[i].punkte=atoi(tmp.c_str());
			}	
			else	// wenn es kein zulssiger string ist, standart verwenden
			{
				list[i].name = STANDARTNAME;
				list[i].punkte = STANDARTPUNKTE;
			}

			i++;
		}

		// Datei wieder schlieen
		in.close();

	}
	else	// wenn datei nicht vorhanden, daten mit standart fllen
	{
		for (i=0;i<anzahl;i++)
		{	
			list[i].name = STANDARTNAME;
			list[i].punkte = STANDARTPUNKTE;
		}
	}
}

void CHighscore::daten_speichern()
{
	// Datei ffnen (inhalt wird dabei gelscht)
	ofstream out(dateiname.c_str());

	// Liste in Datei schreiben
	for (int i=0;i<anzahl;i++)
		out << list[i].name << ';' << list[i].punkte << endl;

	// datei wieder schlieen
	out.close();
}

/*********************************************************\
*  Public Funktionen zum anzeigen und auslesen der Liste  *
\*********************************************************/
void CHighscore::print_to_screen()
{	
	cout << endl;
	
	// Tabellenkopf
	cout << "Pos|" << setw(10) << "Name" << "|" << setw(7) << "Punkte" << endl;
	cout << "---|----------|-------\n";

	// Tabelle
	for (short i=0;i<anzahl;i++)
	{
		cout << setw(3) << i+1;
		cout << "|" << setw(10) << list[i].name;
		cout << "|" << setw(7) << list[i].punkte << endl;
	}

	cout << endl;
}

int CHighscore::getPunkte(int pos)
{
	if ((pos>=0) && (pos <anzahl))
		return list[pos].punkte;
		
	return 0;
}

string CHighscore::getName(int pos)
{
	if ((pos>=0) && (pos <anzahl))
		return list[pos].name;

	return "";
}

/**********************************************************\
*  Public Funktion zum hinzufgen eines Neuen Datensatzes  *
\**********************************************************/
bool CHighscore::addName(string name, int punkte)
{
	if (punkte>list[anzahl-1].punkte)
	{
		list[anzahl-1].name = name;
		list[anzahl-1].punkte = punkte;
		sortieren();
		return true;
	}

	return false;
}
