#include "ClickMain.h"

//////////////////////////////////////////////////////////////////////////////////
//				ClickMain - Standartklasse fr alle Varianten					//
//////////////////////////////////////////////////////////////////////////////////
SDL_Surface* ClickMain::sScreen = 0;
SDL_Surface* ClickMain::sTileSet = 0;
SDL_Rect* ClickMain::rectBall = 0;
SDL_Rect ClickMain::rectWeiter = {0,0,0,0};
SDL_Event ClickMain::paint_event= {SDL_USEREVENT};


ClickMain::ClickMain()
{
	// Zufallszahlengenerator starten
	srand((unsigned)time( NULL ));

	// Standart-Position fr's Nachrcken setzten
	rueck_zeile=FELDHOEHE-1;	// unten
	rueck_spalte=0;				// links

	spielername="";
}

ClickMain::~ClickMain()
{
	if (pScore>0)
	{
		delete pScore;
		pScore=0;
	}
}

string ClickMain::IntToStr(int i)
{
	char tmp[10];
	return itoa(i,tmp,10);
}

bool ClickMain::xyinrect(short x, short y,SDL_Rect *recttest)
{
	// x testen
	if ((x >= recttest->x) && (x < (recttest->x)+(recttest->w)))
		// y testen wenn x wahr ist
		if ((y >= recttest->y) && (y < (recttest->y)+(recttest->h)))
			return true;	// wahr zurckgeben wenn xy in rect

	return false;
}

void ClickMain::highscore_anzeigen(CHighscore* pHScore)
{
	// berschrifftt
	text_zeichnen("Highscore von "+pHScore->scorename,0,10,1,30);

	// Tabelle
	for (short i=0;i<10;i++)
	{	// Ranking
		text_zeichnen(IntToStr(i+1),110,70+i*50,1,35);
		// Namen
		text_zeichnen(pHScore->getName(i),0,70+i*50,1,35);
		// Punkte
		string punkte = ClickMain::IntToStr(pHScore->getPunkte(i));
		text_zeichnen(punkte,700,70+i*50,2,35);
	}
}

void ClickMain::highscore_aendern_anzeigen()
{
	string zeile[5];

	text_zeichnen("Super!",0,10,1,50);

	zeile[0]="Sie haben es in die";
	zeile[1]="Highscore geschafft.";
	zeile[2]="Sie haben "+IntToStr(gesamtpunkte)+" Punkte";
	zeile[3]="Bitte geben sie ihren Namen ein:";
	zeile[4]=spielername;

	for (short i=0;i<5;i++)
		text_zeichnen(zeile[i],0,70+i*50,1,35);
}


void ClickMain::feld_nachruecken()
{
	short i,j,b,h;

	// von oben und dann von unten nach "zeile"
	for (j=0;j<FELDBREITE;j++)
	{
		for (i=rueck_zeile;i>=0;i--)
			if (feld[j][i]==0)
				for (h=i-1;h>=0;h--)
					if (feld[j][h]>0)
					{
						feld[j][i]=feld[j][h];
						feld[j][h]=0;
						break;
					}
		for (i=rueck_zeile;i<FELDHOEHE;i++)
			if (feld[j][i]==0)
				for (h=i+1;h<FELDHOEHE;h++)
					if (feld[j][h]>0)
					{
						feld[j][i]=feld[j][h];
						feld[j][h]=0;
						break;
					}

	}

	// von links und dann von rechts nach "spalte"
	for (j=rueck_spalte;j>=0;j--)
		if (feld[j][rueck_zeile]==0)
			for (b=j-1;b>=0;b--)
				if (feld[b][rueck_zeile]>0)
				{
					for (i=0;i<FELDHOEHE;i++)
					{
						feld[j][i]=feld[b][i];
						feld[b][i]=0;
					}
					break;
				}

	for (j=rueck_spalte;j<FELDBREITE;j++)
		if (feld[j][rueck_zeile]==0)
			for (b=j+1;b<FELDBREITE;b++)
				if (feld[b][rueck_zeile]>0)
				{
					for (i=0;i<FELDHOEHE;i++)
					{
						feld[j][i]=feld[b][i];
						feld[b][i]=0;
					}
					break;
				}
}


int ClickMain::feld_test(short x, short y, short c, bool start)
{
	if (c==0) return 0;

	int punkte = 0;
	// links testen
	if (x>0)
		if (feld[x-1][y]==c)
		{
			punkte+=1;
			feld[x][y]=0;
			punkte+=feld_test(x-1,y,c);
		}

	// oben testen
	if (y>0)
		if (feld[x][y-1]==c)
		{
			punkte+=1;
			feld[x][y]=0;
			punkte+=feld_test(x,y-1,c);
		}

	// rechts testen
	if (x<FELDBREITE-1)
		if (feld[x+1][y]==c)
		{
			punkte+=1;
			feld[x][y]=0;
			punkte+=feld_test(x+1,y,c);
		}

	// unten testen
	if (y<FELDHOEHE-1)
		if (feld[x][y+1]==c)
		{
			punkte+=1;
			feld[x][y]=0;
			punkte+=feld_test(x,y+1,c);
		}
	
	if (!start)	feld[x][y]=0;

	return punkte;
}


void ClickMain::feld_zeichnen()
{
	SDL_Rect rectZiel;
	short i,j;

	for (i=0;i<FELDBREITE;i++)
		for(j=0;j<FELDHOEHE;j++)
		{
			short farbe=feld[i][j];
			if (farbe>0)
			{
				rectZiel.x=i*32;
				rectZiel.y=j*32;
				SDL_BlitSurface(sTileSet,&rectBall[farbe-1],sScreen,&rectZiel);
			}
		}
}


void ClickMain::animation()
{
	#if ANIMATION == 1
		SDL_Rect rectZiel, rectTmp;

		for (short a=1;a<=4;a++)
		{
			for (short i=0;i<FELDBREITE;i++)
				for(short j=0;j<FELDHOEHE;j++)
					if(!(altes_feld[i][j]==feld[i][j]))
					{
						rectTmp = rectBall[altes_feld[i][j]-1];
						rectTmp.y = 32*a;
						rectZiel.x=i*32;
						rectZiel.y=j*32;
						SDL_BlitSurface(sTileSet,&rectTmp,sScreen,&rectZiel);
					}
			SDL_Flip(sScreen);
			SDL_Delay(DAUER_DER_ANIMATION);
		}
	#endif
}


int ClickMain::noch_moeglich()
{
	int moeglichkeiten=0;
	short c;
	bool test=false;

	for (short x=0;x<FELDBREITE;x++)
		for(short y=0;y<FELDHOEHE;y++)
		{
			c=feld[x][y];
			test=false;
			if (c>0)
			{
				// links testen
				if (x>0) if (feld[x-1][y]==c) test=true;

				// oben testen
				if (y>0) if (feld[x][y-1]==c) test=true;

				// rechts testen
				if (x<FELDBREITE-1) if (feld[x+1][y]==c) test=true;

				// unten testen
				if (y<FELDHOEHE-1) if (feld[x][y+1]==c) test=true;
			}
			if (test) moeglichkeiten++;
		}

	return moeglichkeiten;
}


void ClickMain::text_zeichnen(string text, int x, int y, int ausrichtung, int groese, SDL_Rect *rectaus)
{
	if (text.size()>0)
	{
		SDL_Surface *sText;
		SDL_Rect rectZiel;
		SDL_Color bg={0,0,0,0};
		SDL_Color farbe={255,0,0,0};

		// neue Gre oder Standartgre
		TTF_Font *font = 0;
	
		// Font mit neuer Gre laden
		font = TTF_OpenFont("Data/boulder.ttf", groese);
		if(!font) 
		{
			fprintf(stderr,"Konnte Font-File nicht laden!: %s\n", TTF_GetError());
			exit(1);
		}
		// Text mit neuer Font Rendern
		sText=TTF_RenderText_Shaded(font,text.c_str(), farbe, bg);

		// War das Rendern erfoglreich?
		if(!sText)
		{
			fprintf(stderr,"Konnte text nicht in sText schreiben!: %s\n", TTF_GetError());
			exit(1);
		}
	
		// Position der TextSurface
		if (x==0)
			switch (ausrichtung)
			{
				case 0: rectZiel.x=0;break;
				case 1: rectZiel.x=int((SCREEN_BREITE/2)-((sText->w)/2));break;
				case 2: rectZiel.x=int(SCREEN_BREITE-(sText->w));break;
			}
		else 
			switch (ausrichtung)
			{
				case 0: rectZiel.x=x;break;
				case 1: rectZiel.x=int(x-((sText->w)/2));break;
				case 2: rectZiel.x=int(x-(sText->w));break;
			}

		rectZiel.y=y;

		// ausgabe der TextSurface position und gre an rectaus
		if (rectaus>0)
		{
			rectaus->x = rectZiel.x;
			rectaus->y = y;
			rectaus->w = sText->w;
			rectaus->h = sText->h;
		}

		// textSurface blitten und Surface wieder frei geben
		SDL_BlitSurface(sText,0,sScreen,&rectZiel);
		SDL_FreeSurface(sText);	

		// font wieder frei geben
		if (font>0)
			TTF_CloseFont(font);

	} // endif text.size
}

void ClickMain::press(Uint16 taste)
{
	// Fr die Eingabe das Namens in die Highscore

	if((taste < 256) && (taste > 31))
		spielername+=(char)taste;
	
	if (spielername.size()>0)
	{
		if(taste==8)
			spielername.erase(spielername.size()-1);
	}
}
