#if !defined(CLICKMAIN_HEADER)
#define CLICKMAIN_HEADER

#define SCREEN_BREITE 800
#define SCREEN_HOEHE 600
#define FELDBREITE int(SCREEN_BREITE/32)	// 800/32=25
#define FELDHOEHE int(SCREEN_HOEHE/32)		// 600/32=18,75
#define ANIMATION 1		// 0 = keine Animation / 1 = Animieren
#define DAUER_DER_ANIMATION 30	// Geschwindigkeit der Animation


// Includes
#include "CHighscore.h"
#include <string>
#include <time.h>
#include <math.h>
#include <sdl.h>
#include <sdl_ttf.h>
using namespace std;


class ClickMain
{
public:
	ClickMain();
	virtual ~ClickMain();

	// Funktion die berall bentigt wird
	static string IntToStr(int i);
	static bool xyinrect(short x, short y,SDL_Rect *recttest);
	static void highscore_anzeigen(CHighscore* pHScore);
	void press(Uint16 taste);
	static void text_zeichnen(string text, int x, int y, int ausrichtung=0, int groese=18, SDL_Rect *rectaus=0);
	
	// Funktionen die in den Klassen selber definiert werden mssen
	virtual void feld_click(short x, short y)=NULL;
	virtual void zeichnen()=NULL;
	virtual void tick()=NULL;
	virtual void pause()=NULL;

	enum SpielStatus
	{
		SPIEL_LAEUFT,
		SPIEL_LEVELWECHSEL,
		SPIEL_ENDE,
		HIGHSCORE_ANZEIGEN,
		HIGHSCORE_AENDERN,
		SPIEL_PAUSE,
	} status;

	static SDL_Surface *sScreen;
	static SDL_Surface *sTileSet;
	static SDL_Rect *rectBall;
	static SDL_Event paint_event;

protected:
	// Funktionen die berall funktionieren
	void highscore_aendern_anzeigen();
	int feld_test(short x, short y, short c, bool start=false);
	void feld_zeichnen();
	void animation();
	void feld_nachruecken();
	int noch_moeglich();

	// Position wohin nachgerckt wird
	short rueck_zeile,rueck_spalte;
	
	// Variablen
	CHighscore *pScore;
	string spielername;
	int gesamtpunkte;
	static SDL_Rect rectWeiter;
	short anz_farben;
	Uint32 startzeit,endzeit;

	short feld[FELDBREITE][FELDHOEHE];
	short altes_feld[FELDBREITE][FELDHOEHE];
};

#endif