#include "ClickMix.h"

//////////////////////////////////////////////////////////////////////////////////////
//					ClickMix - Rahmenklasse fr das Spiel							//
//////////////////////////////////////////////////////////////////////////////////////
const string ClickMix::name_der_variante[4] = 
{
	"Standart Click",
	"Chaos Click",
	"Speed Click",
	"FallDown Click"
};

ClickMix::ClickMix()
{
	// Fenster Initiieren
	ClickMain::sScreen = SDL_SetVideoMode(SCREEN_BREITE,SCREEN_HOEHE,0,SDL_HWSURFACE|SDL_DOUBLEBUF);

	if(!ClickMain::sScreen)
	{
		fprintf(stderr,"Konnte Bildschirmmodus nicht setzten: %s\n",SDL_GetError());
		exit(1);
	}
	

	// Tileset erzeugen
	create_TileSet();

/* Original-code, nur laden des TileSets
	SDL_Surface *sTmp=0;
	sTmp = SDL_LoadBMP("Data/tilesets.bmp");
	if (!sTmp)
	{
		fprintf(stderr,"Konnte TileSets nicht laden: %s\n",SDL_GetError());
		exit(1);
	}
	ClickMain::sTileSet = SDL_DisplayFormat(sTmp);
	SDL_FreeSurface(sTmp);
*/

	// Speicher fr rectBall reservieren
	ClickMain::rectBall=new SDL_Rect[7];

	// rectBall setzen
	for (short i=0;i<7;i++)
	{
		ClickMain::rectBall[i].x=i*32;
		ClickMain::rectBall[i].y=0;
		ClickMain::rectBall[i].w=ClickMain::rectBall[i].h=32;
	}	

	// Actives TileSet auswhlen
	newTileSet(4);
	
	// Pointer fr Spielvariante auf Null setzten
	pClickVar = 0;

	// Pointer fr Highscore auf Null setzen
	pHScore = 0;

	// Hintergrundmusik laden und wiedergeben
	hintMusik.lade("Data/Musik.wav");
	hintMusik.play();

	// Status des Spiels, und zeichnen
	status = MENUE;

	// neu zeichnen
	SDL_PushEvent(&ClickMain::paint_event);
}

ClickMix::~ClickMix()
{
	// Spielvariante wieder frei geben
	if (pClickVar>0)
		delete pClickVar;

	// speicher von rectBall wieder freigeben
	if (ClickMain::rectBall>0)
		delete [] ClickMain::rectBall;

	// TileSet wieder frei geben
	SDL_FreeSurface(ClickMain::sTileSet);

}

void ClickMix::click(short x,short y)
{
	short i=0;

	switch (status)
	{
	case MENUE:
		if (xyinrect(x,y,&rectMenue[0]))	// Spiel whlen
			status = SPIELWAHL;
		else if (xyinrect(x,y,&rectMenue[1]))	// TileSet whlen
			status = TILESETWAHL;
		else if (xyinrect(x,y,&rectMenue[2]))	// Highscore auswhlen
			status = HIGHSCOREWAHL;
		else if (xyinrect(x,y,&rectMenue[3]))	// Info anzeigen
			status = INFO;
		else if (xyinrect(x,y,&rectMenue[4]))	// Spiel beenden
			exit(0);
		else if (xyinrect(x,y,&rectMusik))	// Hintergrundmusik
		{
			if(hintMusik.status) hintMusik.stop(); else	hintMusik.play();
		}

		break;

	case SPIELWAHL:
		if (xyinrect(x,y,&rectVarianteWahl[0]))
		{
			spielnr = 0;
			pClickVar = new ClickVar1;
			status = SPIELEN;
		}
		else if (xyinrect(x,y,&rectVarianteWahl[1]))
		{
			spielnr= 1;
			status = FARBWAHL;
		}
		else if (xyinrect(x,y,&rectVarianteWahl[2]))
		{
			spielnr = 2;
			status = SCHWWAHL;
		}
		else if (xyinrect(x,y,&rectVarianteWahl[3]))
		{
			spielnr = 3;
			pClickVar = new ClickVar4;
			status = SPIELEN;
		}
		break;

	case FARBWAHL:
		for (i=0;i<4;i++)
			if (xyinrect(x,y,&rectFarbWahl[i]))
			{
				pClickVar = new ClickVar2(2+i);
				status = SPIELEN;
				break;
			}
		break;

	case SCHWWAHL:
		for (i=0;i<3;i++)
			if (xyinrect(x,y,&rectSchwWahl[i]))
			{
				if (spielnr==2)
					pClickVar = new ClickVar3(i);
				else
				{
					fprintf(stderr,"Ungueltige Spielnummer: %d\n",spielnr);
					exit(6);
				}
				status = SPIELEN;
				break;
			}
		break;

	case SPIELEN:
		// Das Klicken an das Spiel weitergeben
		pClickVar->feld_click(x,y);

		// berprfen ob der Spieler das Spiel verlassen will
		if (xyinrect(x,y,&rectFrage))
		{
			pClickVar->pause();
			status=ENDEFRAGE;
		}

		break;

	case TILESETWAHL:
		for (i=0;i<5;i++)
			if (xyinrect(x,y,&rectTileSetWahl[i]))
			{
				newTileSet(i);
				status=MENUE;
				break;
			}
		break;

	case HIGHSCOREWAHL:
		for(i=0;i<4;i++)
			if (xyinrect(x,y,&rectHighscoreWahl[i]))
			{
				string datei="Data/var" + ClickMain::IntToStr(i+1) + ".hsc";
				pHScore = new CHighscore(name_der_variante[i],datei);
				status = HIGHSCORE;
			}
		break;

	case HIGHSCORE:
		break;

	case ENDEFRAGE:
		if (xyinrect(x,y,&rectFrage))
		{
			status=SPIELEN;
		}
		break;

	case INFO:
		break;
	}
	
	if (xyinrect(x,y,&rectBack))
	{
		if (pHScore>0)
		{
			delete pHScore;
			pHScore=0;
		}

		// Fehler abfangen beim Lschen des VariantenObjektes
		// (irgend ein Fehler, den ich nicht lsen kann, beim
		// lschen von Variante 4)
		if (pClickVar>0)
		{
			try
			{
				delete pClickVar;
			}
			catch(...)
			{
			}
			pClickVar=0;
		}
		status=MENUE;
	}

	SDL_PushEvent(&ClickMain::paint_event);
}

void ClickMix::zeichnen()
{
	static Uint32 schwarz = SDL_MapRGB(ClickMain::sScreen->format,0,0,0);
	short i=0;
	string zeile[10];

	// rectBack auf null setzten
	rectBack.x=rectBack.y=rectBack.h=rectBack.w=0;
	
	// Hintergrund schwarz zeichnen
	SDL_FillRect(ClickMain::sScreen,0,schwarz);

	switch (status)
	{
	case MENUE:
		text_zeichnen("C L I C K   M I X",72,0,10,1);
		text_zeichnen("Spielen",30,0,130,1,&rectMenue[0]);
		text_zeichnen("TileSet",30,0,180,1,&rectMenue[1]);
		text_zeichnen("Highscores",30,0,230,1,&rectMenue[2]);
		text_zeichnen("Info",30,0,280,1,&rectMenue[3]);
		text_zeichnen("Ende",30,0,330,1,&rectMenue[4]);
		
		if(hintMusik.status) zeile[0]="Hintergrundmusik aus";
		else zeile[0]="Hintergrundmusik an";
		text_zeichnen(zeile[0],18,0,FELDHOEHE*32,1,&rectMusik);

		break;

	case SPIELWAHL:
		text_zeichnen("Welche Spielvariante spielen?",50,0,10,1);

		text_zeichnen(name_der_variante[0],35,0,100,1,&rectVarianteWahl[0]);
		zeile[0]="Standartvariante mit 6 Level.";
		zeile[1]="Mit jedem Level werden es mehr Farben.";
		for (i=0;i<2;i++)
			text_zeichnen(zeile[i],16,0,140+i*22,1);

		text_zeichnen(name_der_variante[1],35,0,200,1,&rectVarianteWahl[1]);
		zeile[0]="Bei jedem Click in das Feld,";
		zeile[1]="wird das Feld woanders zentriert.";
		for (i=0;i<2;i++)
			text_zeichnen(zeile[i],16,0,240+i*22,1);

		text_zeichnen(name_der_variante[2],35,0,300,1,&rectVarianteWahl[2]);
		zeile[0]="Mit jeder Sekunde werden Punkte abgezogen.";
		zeile[1]="Bei weniger als 0 Punkten ist das Spiel zuende!";
		for (i=0;i<3;i++)
			text_zeichnen(zeile[i],16,0,340+i*22,1);

		text_zeichnen(name_der_variante[3],35,0,400,1,&rectVarianteWahl[3]);
		zeile[0]="Die Oberste Reihe wird stndig gefllt.";
		zeile[1]="Wenn sie nicht gefllt werden kann, hat man Verloren!";
		for (i=0;i<3;i++)
			text_zeichnen(zeile[i],16,0,440+i*22,1);

		text_zeichnen("zurck zum Men",18,0,FELDHOEHE*32,1,&rectBack);
		break;

	case FARBWAHL:
		text_zeichnen("Mit wievel Farben spielen?",50,0,10,1);
		text_zeichnen("zwei Farben",35,0,100,1,&rectFarbWahl[0]);
		text_zeichnen("drei Farben",35,0,150,1,&rectFarbWahl[1]);
		text_zeichnen("vier Farben",35,0,200,1,&rectFarbWahl[2]);
		text_zeichnen("fnf Farben",35,0,250,1,&rectFarbWahl[3]);

		text_zeichnen("zurck zum Men",18,0,FELDHOEHE*32,1,&rectBack);
		break;

	case SCHWWAHL:
		text_zeichnen("Welche Schwierigkeitsstufe?",50,0,10,1);
		text_zeichnen("Leicht",35,0,100,1,&rectSchwWahl[0]);
		text_zeichnen("Mittel",35,0,150,1,&rectSchwWahl[1]);
		text_zeichnen("Schwer",35,0,200,1,&rectSchwWahl[2]);

		text_zeichnen("zurck zum Men",18,0,FELDHOEHE*32,1,&rectBack);
		break;

	case SPIELEN:
		pClickVar->zeichnen();
		if (pClickVar->status == 0)
			text_zeichnen("(ende)",18,200,FELDHOEHE*32,0,&rectFrage);
		else if(pClickVar->status == 3)
			text_zeichnen("zurck zum Men",18,0,FELDHOEHE*32,1,&rectBack);
		
		break;

	case TILESETWAHL:
		text_zeichnen("Welches TileSet verwenden?",50,0,10,1);

		// alle TileSet zeichne
		for (i=0;i<5;i++)
		{
			newTileSet(i);
			SDL_Rect rectZiel={0,0,0,0};
			
			// Position des TileSet
			short x=30+i*150,y=200;

			// text ber TileSet
			text_zeichnen("TileSet " + ClickMain::IntToStr(i+1),16,x+29,y-20);

			// TileSet zeichnen
			for (short j=0;j<4;j++)
			{
				rectZiel.y = y + 32*j;
				rectZiel.x = x;
				SDL_BlitSurface(ClickMain::sTileSet,&ClickMain::rectBall[j],ClickMain::sScreen,&rectZiel);
				rectZiel.x = x + 32;
				SDL_BlitSurface(ClickMain::sTileSet,&ClickMain::rectBall[j*2],ClickMain::sScreen,&rectZiel);
				rectZiel.x = x + 64;
				SDL_BlitSurface(ClickMain::sTileSet,&ClickMain::rectBall[j*2],ClickMain::sScreen,&rectZiel);
				rectZiel.x = x + 96;
				SDL_BlitSurface(ClickMain::sTileSet,&ClickMain::rectBall[j],ClickMain::sScreen,&rectZiel);
			}

			// das rect fr die Auswahl des TileSets
			rectTileSetWahl[i].x=x;
			rectTileSetWahl[i].y=y-20;
			rectTileSetWahl[i].w=128;
			rectTileSetWahl[i].h=148;
		}
		text_zeichnen("zurck zum Men",18,0,FELDHOEHE*32,1,&rectBack);
		break;

	case HIGHSCOREWAHL:
		text_zeichnen("Welche Highscore anzeigen?",50,0,10,1);
		for (i=0;i<4;i++)
			text_zeichnen(name_der_variante[i],35,0,110+50*i,1,&rectHighscoreWahl[i]);

		text_zeichnen("zurck zum Men",18,0,FELDHOEHE*32,1,&rectBack);
		break;

	case HIGHSCORE:
		ClickMain::highscore_anzeigen(pHScore);

		text_zeichnen("zurck zum Men",18,0,FELDHOEHE*32,1,&rectBack);
		break;

	case ENDEFRAGE:
		text_zeichnen("Wirklich beenden",45,0,(SCREEN_HOEHE/3)-50,1);
		text_zeichnen("Ja",30,(SCREEN_BREITE/2)-75,SCREEN_HOEHE/3,2,&rectBack);
		text_zeichnen("Nein",30,(SCREEN_BREITE/2)+75,SCREEN_HOEHE/3,0,&rectFrage);
		break;

	case INFO:
		text_zeichnen("T E S T V E R S I O N",46,0,30,1);
		text_zeichnen("Programmed by McSpecky",30,0,100,1);
		text_zeichnen("Copyright by McS Soft.",30,0,150,1);

		text_zeichnen("zurck zum Men",18,0,FELDHOEHE*32,1,&rectBack);
		break;
	}

	SDL_Flip(ClickMain::sScreen);


}

void ClickMix::press(Uint16 taste)
{
	if (status==SPIELEN)
		if (pClickVar->status==4)
		{
			pClickVar->press(taste);
			zeichnen();
		}
}

void ClickMix::tick()
{
	if (status==SPIELEN)
		if (pClickVar->status==0)
			pClickVar->tick();
}

void ClickMix::newTileSet(short nr)
{
	for (short i=0;i<7;i++)
		ClickMain::rectBall[i].y=nr*160;
}

void ClickMix::create_TileSet()
{
	// bentigte Variablen
	SDL_Surface* fertig=0;
	SDL_Surface* vorlage=0;
	SDL_Surface* farbige_vorlage=0;
	SDL_Surface* tmp=0;
	Uint8 r,g,b;
	Uint32 keycolor, farbe1, farbe2;
	SDL_Rect ziel;

	// Bild mit der Vorlage laden
	tmp=SDL_LoadBMP("Data/tileset.bmp");
	if(!tmp)
	{
		fprintf(stderr,"Konnte Data/tileset.bmp nicht laden.\n");
		exit(1);
	}
	keycolor=SDL_MapRGB(tmp->format,255,255,255);
	SDL_SetColorKey(tmp,SDL_SRCCOLORKEY,keycolor);
	vorlage=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	tmp=0;

	// Surface fr die farbige Vorlage erzeugen
	tmp=SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCCOLORKEY,	vorlage->w, vorlage->h,
								8, 0, 0, 0, 0);
	SDL_SetColorKey(tmp,SDL_SRCCOLORKEY,0);
	farbige_vorlage=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	tmp=0;

	// Surface fr die TileSets erzeugen
	tmp=SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCCOLORKEY,	(vorlage->w/2)*7, vorlage->h,
							8, 0, 0, 0, 0);
	//SDL_SetColorKey(tmp,SDL_SRCCOLORKEY,0);
	fertig=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	tmp=0;
	// Hintergrund der TileSetSurface Schwarz
	SDL_FillRect(fertig,0,0);

	// Anfangsposition des Ziel_rects
	ziel.x=ziel.y=0;
	ziel.w=vorlage->w/2;
	ziel.h=vorlage->h;

	for(int i=0; i<7; i++)
	{
		// Farben bestimmen
		switch (i)
		{
			case 0: r=255; g=0;   b=0;   break;	// Rot
			case 1: r=0;   g=255; b=0;   break;	// Grn
			case 2: r=0;   g=0;   b=255; break; // Blau
			case 3: r=255; g=255; b=0;   break; // Gelb
			case 4: r=0;   g=255; b=255; break; // Cyan
			case 5: r=255; g=0;   b=255; break;	// Magenta
			case 6: r=200; g=200; b=200; break; // Grau
		}

		farbe1=SDL_MapRGB(farbige_vorlage->format,r/2,g/2,b/2);
		farbe2=SDL_MapRGB(farbige_vorlage->format,r,g,b);

		// Farben zeichnen
		SDL_Rect feld1={0,0,vorlage->w/2, vorlage->h};
		SDL_Rect feld2={vorlage->w/2,0,vorlage->w/2, vorlage->h};
		SDL_FillRect(farbige_vorlage,&feld1,farbe1);
		SDL_FillRect(farbige_vorlage,&feld2,farbe2);

		// Die Vorlage darber blitten
		SDL_BlitSurface(vorlage,0,farbige_vorlage,0);

		// Die fertige Surface fllen
		ziel.x=i*ziel.w;
		SDL_BlitSurface(farbige_vorlage,&feld1,fertig,&ziel);
		SDL_BlitSurface(farbige_vorlage,&feld2,fertig,&ziel);
	}

	// benutzten Zwischenspeicher wieder freigeben
	SDL_FreeSurface (vorlage);
	SDL_FreeSurface (farbige_vorlage);

	ClickMain::sTileSet=fertig;
}
