#if !defined(CLICKMIX_HEADER)
#define CLICKMIX_HEADER

// Includes
#include <string>
#include <sdl.h>
#include <sdl_ttf.h>

// Tools
#include "CHighscore.h"
#include "audio.h"

// Standartklasse
#include "ClickMain.h"

// Spielvarianten
#include "ClickVar1.h"	// Standart Click
#include "ClickVar2.h"	// Chaos Click
#include "ClickVar3.h"	// Speed Click
#include "ClickVar4.h"	// FallDown Click

using namespace std;

class ClickMix
{
public:
	ClickMix();
	~ClickMix();
	void click(short x, short y);
	void press(Uint16 taste);
	void tick();
	void zeichnen();

	const static string name_der_variante[4];
	short spielnr;
	
private:
	void create_TileSet();	// erzeugt aus der Vorlage die TileSets
	void newTileSet(short nr);
	bool xyinrect(short x, short y, SDL_Rect *recttest){return ClickMain::xyinrect(x,y,recttest);};

	// Um text zu zeichnen, die Funktion aus ClickMain benutzen
	void text_zeichnen(string text, int groese, int x, int y, int ausrichtung=0, SDL_Rect *rectaus=0)
		{ClickMain::text_zeichnen(text,x,y,ausrichtung,groese,rectaus);};

	// Variablen fr das Spiel
	ClickMain* pClickVar;
	CHighscore* pHScore;

	enum MenuStatus
	{
		MENUE,
		SPIELWAHL,
		FARBWAHL,
		SCHWWAHL,
		SPIELEN,
		TILESETWAHL,
		INFO,
		HIGHSCOREWAHL,
		HIGHSCORE,
		ENDEFRAGE
	} status;

	// Rects fr die Abfrage des Mausklicks
	SDL_Rect rectMenue[5];
	SDL_Rect rectTileSetWahl[5];
	SDL_Rect rectFarbWahl[4];
	SDL_Rect rectSchwWahl[3];
	SDL_Rect rectBack;
	SDL_Rect rectVarianteWahl[4];
	SDL_Rect rectHighscoreWahl[4];
	SDL_Rect rectFrage;
	SDL_Rect rectMusik;

	// Die Hintergrundmusik
	CAudio hintMusik;
};

#endif