#include "ClickVar1.h"

//////////////////////////////////////////////////////////////////////////////
//				ClickVar1 - erste Variante von ClickMix						//
//////////////////////////////////////////////////////////////////////////////
// Beschreibung: Das ist die Standart Variante. Es gibt 6 Level und bei		//
//				 jedem Level kommt eine Farbe mehr dazu.					//
//				 Der Spieler muss so viel wie mglich Steine abrumen.		//
//				 Je schneller er ist und je weniger Clicks er braucht,		//
//				 um so mehr Bonuspunkte bekommt er.							//
//////////////////////////////////////////////////////////////////////////////

ClickVar1::ClickVar1()
{
	// Pointer zur Highscore liste
	pScore = new CHighscore("Standart Click","Data/var1.hsc");

	// Init der Variante
	level=1;
	erg_gesamt.anzahl_clicks=erg_gesamt.nochda=erg_gesamt.zeit=erg_gesamt.punkte=erg_gesamt.bonus=0;
	level_start();
}

ClickVar1::~ClickVar1()
{

}

void ClickVar1::level_start()
{
	// Zhl-Variablen auf 0 setzen
	erg_level.anzahl_clicks=erg_level.nochda=erg_level.zeit=erg_level.punkte=erg_level.bonus=0;

	// feld zufllig fllen
	srand((unsigned)time( NULL ));
	for (short i=0;i<FELDBREITE;i++)
		for(short j=0;j<FELDHOEHE;j++)
			feld[i][j]=short(1+rand()%(level+1));
	
	endzeit=0;
	status=SPIEL_LAEUFT;
}

void ClickVar1::level_ende()
{
	endzeit=SDL_GetTicks();
	erg_level.zeit = (endzeit-startzeit)/1000;

	for (short i=0;i<FELDBREITE;i++)
		for(short j=0;j<FELDHOEHE;j++)
			if(feld[i][j]>0) erg_level.nochda++;

	// levelergebniss berechnen
	erg_level.bonus=(erg_level.punkte/erg_level.anzahl_clicks) - ((erg_level.nochda*100)/(FELDHOEHE*FELDBREITE));
	if (erg_level.bonus>1) erg_level.bonus= pow(erg_level.bonus , level);
	if (erg_level.zeit>0) erg_level.bonus/=erg_level.zeit;
	if (erg_level.bonus<0) erg_level.bonus = 0;

	// werte bei gesamt hinzufgen
	erg_gesamt.punkte		+=erg_level.bonus + erg_level.punkte;
	erg_gesamt.anzahl_clicks+=erg_level.anzahl_clicks;
	erg_gesamt.nochda		+=erg_level.nochda;
	erg_gesamt.zeit			+=erg_level.zeit;
	erg_gesamt.bonus		+=erg_level.bonus;


	// Spiel Zeichnen
	status=SPIEL_LEVELWECHSEL;
}


void ClickVar1::zeichnen()
{
	short i;
	string text,zeile[15];

	switch (status)
	{
	// Elemente des Spiels Anzeigen
	case SPIEL_LAEUFT:
		// Feld zeichnen
		feld_zeichnen();

		// Text fr Spiel zeichnen
		zeile[0] = "Punkte: " + IntToStr(erg_level.punkte);
		zeile[1] = "Klicks: " + IntToStr(erg_level.anzahl_clicks);
		zeile[2] = "Mglichkeiten: " + IntToStr(noch_moeglich());

		for(i=0;i<3;i++)
			text_zeichnen(zeile[i],0,FELDHOEHE*32,i);

		break;

	
	case SPIEL_LEVELWECHSEL:
		// Feld zeichnen
		feld_zeichnen();

		// Levelergebniss anzeigen
		zeile[0] = "Zwischenergebniss Level " + IntToStr(level);
		zeile[1] = "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~";
		zeile[2] = "Punkte: " + IntToStr(erg_level.punkte);
		zeile[3] = "Klicks: " + IntToStr(erg_level.anzahl_clicks);

		if (erg_level.anzahl_clicks!=0)
			zeile[4] = "Punkte pro Klick: " + IntToStr(erg_level.punkte/erg_level.anzahl_clicks);
		
		zeile[5] = "Nicht entfernt: " + IntToStr((erg_level.nochda*100)/(FELDHOEHE*FELDBREITE)) + " %";
		zeile[6] = "Schwierigkeit: " + IntToStr(level+1) + " Farben";
		zeile[7] = "Bentigte Zeit: " + IntToStr(erg_level.zeit) + " Sekunden";
		zeile[8] = "-> Bonus: " + IntToStr(erg_level.bonus) + " Punkte";
		zeile[9] = "-------------------------------------";
		zeile[10]= "Ergebniss fr dieses Level:";
		zeile[11]= IntToStr(erg_level.punkte+erg_level.bonus) + " Punkte";
		zeile[12]= "-------------------------------------";
		zeile[13]= "Derzeitiges Gesamtergebniss:";
		zeile[14]= IntToStr(erg_gesamt.punkte) + " Punkte";

		for (i=0;i<15;i++)
			text_zeichnen(zeile[i],0,50+(i*25),1);

		text_zeichnen("weiter",0,FELDHOEHE*32,1,18,&rectWeiter);
		break;

	// Endergebniss des Spiels anzeigen
	case SPIEL_ENDE:
		zeile[0] = "Endeergebniss des Spiels";
		zeile[1] = "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~";
		zeile[2] = "Punkte: " + IntToStr(erg_gesamt.punkte);
		zeile[3] = "Klicks: " + IntToStr(erg_gesamt.anzahl_clicks);

		if (erg_gesamt.anzahl_clicks!=0)
			zeile[4] = "Punkte pro Klick: " + IntToStr(erg_gesamt.punkte/erg_gesamt.anzahl_clicks);
		
		zeile[5] = "Nicht entfernt: " + IntToStr((erg_gesamt.nochda*100)/(FELDHOEHE*FELDBREITE*level)) + " %";
		zeile[6] = "Bentigte Zeit: " + IntToStr(erg_gesamt.zeit ) + " Sekunden";
		zeile[7] = "-------------------------------------";
		zeile[8] = "Gesamtergebniss: " + IntToStr(erg_gesamt.punkte) + " Punkte";

		for (i=0;i<9;i++)
			text_zeichnen(zeile[i],0,50+(i*25),1);

		text_zeichnen("weiter",0,FELDHOEHE*32,1,18,&rectWeiter);
		break;

	case HIGHSCORE_ANZEIGEN:
		highscore_anzeigen(pScore);
		break;

	case HIGHSCORE_AENDERN:
		highscore_aendern_anzeigen();
		text_zeichnen("weiter",0,FELDHOEHE*32,1,18,&rectWeiter);
		break;
	}
}


void ClickVar1::feld_click(short x, short y)
{
	short feldx = x/32;
	short feldy = y/32;
	
	switch (status)
	{
	case SPIEL_LAEUFT:
		if ((feldx<FELDBREITE)&&(feldy<FELDHOEHE))
		{	
			short farbe = feld[feldx][feldy];

			if (farbe>0)
			{
				// Beim ersten Clicken die Stoppuhr starten
				if (erg_level.anzahl_clicks==0) startzeit=SDL_GetTicks();

				// Clicks erhhen
				erg_level.anzahl_clicks++;
				// altes Feld speichern, damit es spter animiert werden kann
				for (short i=0;i<FELDBREITE;i++)
					for(short j=0;j<FELDHOEHE;j++)
						altes_feld[i][j]=feld[i][j];
			}
			
			// gibt es punkte fr den Click
			int p=feld_test(feldx,feldy,farbe,true);
			if(0<p)
			{
				// Punkte speichern
				erg_level.punkte+=p*(level+1);
				// Animation (Verschwinden der Blle)
				animation();
				// Nachrcken des Feldes
				feld_nachruecken();
			}
		}

		// Spiel ende?
		if (noch_moeglich()==0) level_ende();
		break;

	case SPIEL_LEVELWECHSEL:
		if(xyinrect(x,y,&rectWeiter))
			if (level==6)
				status=SPIEL_ENDE;
			else 
			{
				level++;
				level_start();
			}
		break;

	case SPIEL_ENDE:
		if(xyinrect(x,y,&rectWeiter))
		{
			gesamtpunkte = erg_gesamt.punkte;
			if (gesamtpunkte > pScore->getMin())
				status = HIGHSCORE_AENDERN;
			else
				status = HIGHSCORE_ANZEIGEN;
		}
		break;

	case HIGHSCORE_ANZEIGEN:
		break;

	case HIGHSCORE_AENDERN:
		if(xyinrect(x,y,&rectWeiter))
			if (spielername.size()>0)
			{
				pScore->addName(spielername,gesamtpunkte);
				status=HIGHSCORE_ANZEIGEN;
			}
			break;
	}
}
