#include "ClickVar2.h"

//////////////////////////////////////////////////////////////////////////////
//				ClickVar2 - zweite Variante von ClickMix					//
//////////////////////////////////////////////////////////////////////////////
// Beschreibung: Das Feld wird bei jedem Click zufllig an einer anderen    //
//				 nachgerckt. Daraus ergibt sich eine Orientierungslosigkeit//
//				 des Spielers.												//
//////////////////////////////////////////////////////////////////////////////


ClickVar2::ClickVar2(short farben)
{
	// Init der Variante
	anz_farben=farben;
	erg_gesamt.anzahl_clicks=erg_gesamt.nochda=erg_gesamt.zeit=erg_gesamt.punkte=erg_gesamt.bonus=0;

	// zufllig eine nachrueck-position setzten
	rueck_zeile = rand()%FELDHOEHE;
	rueck_spalte= rand()%FELDBREITE;

	// Pointer zur Highscore liste
	pScore = new CHighscore("Chaos Click","Data/var2.hsc");

	// spiel starten
	start();
}

ClickVar2::~ClickVar2()
{

}

void ClickVar2::start()
{
	// feld zufllig fllen
	for (short i=0;i<FELDBREITE;i++)
		for(short j=0;j<FELDHOEHE;j++)
			feld[i][j]=short(1+rand()%anz_farben);
	
	endzeit=0;
	status=SPIEL_LAEUFT;
}

void ClickVar2::ende()
{
	endzeit=SDL_GetTicks();
	erg_gesamt.zeit = (endzeit-startzeit)/1000;

	for (short i=0;i<FELDBREITE;i++)
		for(short j=0;j<FELDHOEHE;j++)
			if(feld[i][j]>0) erg_gesamt.nochda++;

	// Ergebniss berechnen
	erg_gesamt.bonus=(erg_gesamt.punkte/erg_gesamt.anzahl_clicks) - ((erg_gesamt.nochda*100)/(FELDHOEHE*FELDBREITE));
	if (erg_gesamt.bonus>1) erg_gesamt.bonus= pow(erg_gesamt.bonus,anz_farben-1);
	erg_gesamt.bonus/=erg_gesamt.zeit;
	if (erg_gesamt.bonus<0) erg_gesamt.bonus = 0;

	// Spiel beenden
	status=SPIEL_ENDE;
}


void ClickVar2::zeichnen()
{
	short i;
	string text,zeile[11];

	switch (status)
	{
	// Elemente des Spiels Anzeigen
	case SPIEL_LAEUFT:
		// Feld zeichnen
		feld_zeichnen();
		// Text fr Spiel zeichnen
		zeile[0] = "Punkte: " + IntToStr(erg_gesamt.punkte);
		zeile[1] = "Klicks: " + IntToStr(erg_gesamt.anzahl_clicks);
		zeile[2] = "Mglichkeiten: " + IntToStr(noch_moeglich());

		for(i=0;i<3;i++)
			text_zeichnen(zeile[i],0,FELDHOEHE*32,i);

		break;

	// Endergebniss des Spiels anzeigen
	case SPIEL_ENDE:
		zeile[0] = "Endeergebniss des Spiels";
		zeile[1] = "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~";
		zeile[2] = "Punkte: " + IntToStr(erg_gesamt.punkte);
		zeile[3] = "Klicks: " + IntToStr(erg_gesamt.anzahl_clicks);

		if (erg_gesamt.anzahl_clicks!=0)
			zeile[4] = "Punkte pro Klick: " + IntToStr(erg_gesamt.punkte/erg_gesamt.anzahl_clicks);
		
		zeile[5] = "Nicht entfernt: " + IntToStr((erg_gesamt.nochda*100)/(FELDHOEHE*FELDBREITE)) + " %";
		zeile[6] = "Schwierigkeit: " + IntToStr(anz_farben) + " Farben";
		zeile[7] = "Bentigte Zeit: " + IntToStr(erg_gesamt.zeit) + " Sekunden";
		zeile[8] = "-> Bonus: " + IntToStr(erg_gesamt.bonus) + " Punkte";
		zeile[9] = "-------------------------------------";
		zeile[10] = "Gesamtergebniss: " + IntToStr(erg_gesamt.punkte+erg_gesamt.bonus) + " Punkte";

		for (i=0;i<11;i++)
			text_zeichnen(zeile[i],0,50+(i*25),1);

		text_zeichnen("weiter",0,FELDHOEHE*32,1,18,&rectWeiter);
		break;

	case HIGHSCORE_ANZEIGEN:
		highscore_anzeigen(pScore);
		break;

	case HIGHSCORE_AENDERN:
		highscore_aendern_anzeigen();
		text_zeichnen("weiter",0,FELDHOEHE*32,1,18,&rectWeiter);
		break;
	}
}


void ClickVar2::feld_click(short x, short y)
{
	short feldx = x/32;
	short feldy = y/32;
	
	switch (status)
	{
	case SPIEL_LAEUFT:
		if ((feldx<FELDBREITE)&&(feldy<FELDHOEHE))
		{	
			short farbe = feld[feldx][feldy];

			if (farbe>0)
			{
				// Beim ersten Clicken die Stoppuhr starten
				if (erg_gesamt.anzahl_clicks==0) startzeit=SDL_GetTicks();

				// Clicks erhhen
				erg_gesamt.anzahl_clicks++;
				// altes Feld speichern, damit es spter animiert werden kann
				for (short i=0;i<FELDBREITE;i++)
					for(short j=0;j<FELDHOEHE;j++)
						altes_feld[i][j]=feld[i][j];
			}
			
			// gibt es punkte fr den Click
			int p=feld_test(feldx,feldy,farbe,true);
			if(0<p)
			{
				// Punkte speichern
				erg_gesamt.punkte+=p*(anz_farben+1);
				// Animation (Verschwinden der Blle)
				animation();
			}

			// zufllig eine nachrueck-position setzten
			rueck_zeile = rand()%FELDHOEHE;
			rueck_spalte= rand()%FELDBREITE;
			// Nachrcken des Feldes
			feld_nachruecken();
		}

		// Spiel ende?
		if (noch_moeglich()==0) ende();
		break;

	case SPIEL_ENDE:
		if(xyinrect(x,y,&rectWeiter))
		{
			gesamtpunkte = erg_gesamt.punkte+erg_gesamt.bonus;
			if (gesamtpunkte > pScore->getMin())
				status = HIGHSCORE_AENDERN;
			else
				status = HIGHSCORE_ANZEIGEN;
		}
		break;

	case HIGHSCORE_ANZEIGEN:
		break;

	case HIGHSCORE_AENDERN:
		if(xyinrect(x,y,&rectWeiter))
			if (spielername.size()>0)
			{
				pScore->addName(spielername+" ("+IntToStr(anz_farben)+")",gesamtpunkte);
				status=HIGHSCORE_ANZEIGEN;
			}
		break;
	}
}
