#include "ClickVar3.h"

//////////////////////////////////////////////////////////////////////////////
//				ClickVar3 - zweite Variante von ClickMix					//
//////////////////////////////////////////////////////////////////////////////
// Beschreibung: Jede Sekunde die nach Spielbeginn vergeht, wird der		//
//				 Punktestand um 10 Punkte verringert.						//
//				 Bei einem Fehlclick werden ebenfalls 10 Punkte abgezogen!	//
//				 Wenn er kleiner als 0 wird, ist das Spiel beendet.			//
//				 Als Gemeinheit, wird aller 10 Click, das Feld in einer		//
//				 anderen Ecke zentriert.									//
//////////////////////////////////////////////////////////////////////////////

ClickVar3::ClickVar3(short schw)
{
	// schwierigkeitsgrad anpassen
	schwierigkeit=schw;
	switch (schw)
	{
	case 0:	punkteabzug=5; anz_farben=3; punkte=100; break;
	case 1:	punkteabzug=3; anz_farben=2; punkte=200; break;
	case 2: punkteabzug=3; anz_farben=2; punkte=300; break;
	}
	
	// nachrueck-position auf links unten setzten
	rueck_zeile = FELDHOEHE-1;
	rueck_spalte= 0;

	// Pointer zur Highscore liste
	pScore = new CHighscore("Speed Click","Data/var3.hsc");

	// spiel starten
	start();
}

ClickVar3::~ClickVar3()
{

}

void ClickVar3::start()
{
	// feld zufllig fllen
	for (short i=0;i<FELDBREITE;i++)
		for(short j=0;j<FELDHOEHE;j++)
			feld[i][j]=short(1+rand()%anz_farben);
	
	endzeit=startzeit=0;
	anzahl_clicks=0;
	zeit=0;

	status=SPIEL_LAEUFT;
}

void ClickVar3::ende()
{
	// timer beenden
	endzeit=SDL_GetTicks();

	// verstrichene zeit
	zeit+= (endzeit-startzeit)/1000;

	// ergebniss berechnen
	gesamtpunkte = zeit + anz_farben*100*(schwierigkeit+1);
	if (punkte>0)
	{
		gesamtpunkte+=punkte;
		gesamtpunkte+=schwierigkeit*1000;
	}
	
	// Spiel beenden
	status=SPIEL_ENDE;
	
	// neu zeichnen
	SDL_PushEvent(&paint_event);
}

void ClickVar3::tick()
{
	if ((startzeit>0)&&(endzeit==0))
	{
		punkte-=punkteabzug;
		if (punkte<0)
		{
			ende();
			return;
		}
		text_zeichnen("Punkte: " + IntToStr(punkte)+"    ",0,FELDHOEHE*32,0);
		
		// neu zeichnen
		SDL_PushEvent(&paint_event);	
	}
}

void ClickVar3::pause()
{
	endzeit=SDL_GetTicks();
	zeit+=(endzeit-startzeit)/1000;
	endzeit=startzeit=0;
	status=SPIEL_PAUSE;
}

void ClickVar3::nextlevel()
{
	// eine farbe mehr
	anz_farben++;

	if (anz_farben>7)
		ende();
	else
	{
		// feld zufllig fllen
		for (short i=0;i<FELDBREITE;i++)
			for(short j=0;j<FELDHOEHE;j++)
				feld[i][j]=short(1+rand()%anz_farben);

		punkte+=40*schwierigkeit;

		zeichnen();
	}
}

void ClickVar3::zeichnen()
{
	short i;
	string zeile[11];

	// obere Position des Textes
	switch (status)
	{
	// Elemente des Spiels Anzeigen
	case SPIEL_LAEUFT:
		// Feld zeichnen
		feld_zeichnen();
		// Text fr Spiel zeichnen
		text_zeichnen("Punkte: " + IntToStr(punkte),0,FELDHOEHE*32,0);
		text_zeichnen("(pause)",0,FELDHOEHE*32,1,18,&rectPause);
		text_zeichnen("Mglichkeiten: " + IntToStr(noch_moeglich()),0,FELDHOEHE*32,2);

		break;

	// Endergebniss des Spiels anzeigen
	case SPIEL_ENDE:
		if (punkte>=0)
		{
			zeile[0]="Gewonnen!";
			zeile[3]="RestPunkte: " + IntToStr(punkte);
			zeile[8]="-> GewinnBonus: " + IntToStr(schwierigkeit*1000);
		}
		else
		{	
			zeile[0]="Leider Verloren!";
			zeile[3]="RestPunkte: 0";
			zeile[8]="";
		}

		zeile[1] = "Endeergebniss des Spiels";
		zeile[2] = "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~";
		zeile[4] = "Zeit: " + IntToStr(zeit) + " Sekunden";
		zeile[5] = "Farben: " + IntToStr(anz_farben);
		
		zeile[6] = "Schwierigkeit: ";
		switch (schwierigkeit)
		{
		case 0: zeile[6]+="Leicht";break;
		case 1: zeile[6]+="Mittel";break;
		case 2: zeile[6]+="Schwer";break;
		}
		
		zeile[7] = "-> Bonus: " + IntToStr(anz_farben*100*(schwierigkeit+1));
		zeile[9] = "-------------------------------------";
		zeile[10] = "Gesamtergebniss: " + IntToStr(gesamtpunkte);


		text_zeichnen(zeile[0],0,10,1,35);
		for(i=1;i<11;i++)
			text_zeichnen(zeile[i],0,50+i*25,1);

		text_zeichnen("weiter",0,FELDHOEHE*32,1,18,&rectWeiter);
		break;

	case HIGHSCORE_ANZEIGEN:
		highscore_anzeigen(pScore);
		break;

	case HIGHSCORE_AENDERN:
		highscore_aendern_anzeigen();
		text_zeichnen("weiter",0,FELDHOEHE*32,1,18,&rectWeiter);
		break;

	case SPIEL_PAUSE:
		text_zeichnen(" P A U S E ! ",0,SCREEN_HOEHE/3,1,90);
	}
}


void ClickVar3::feld_click(short x, short y)
{
	short feldx = x/32;
	short feldy = y/32;
	
	switch (status)
	{
	case SPIEL_LAEUFT:
		if (xyinrect(x,y,&rectPause))
		{
			pause();
			break;
		}

		if ((feldx<FELDBREITE)&&(feldy<FELDHOEHE))
		{	
			short farbe = feld[feldx][feldy];

			if (farbe>0)
			{
				// Beim ersten Clicken die Stoppuhr und Timer starten
				if (startzeit==0)
					startzeit=SDL_GetTicks();

				// Clicks erhhen
				anzahl_clicks++;

				// bei jedem 10ten Click das Feld in einer anderen ecke zentrieren
				if (anzahl_clicks%10 == 0)
				{
					short n=rand()%4;
					switch (n)
					{
						case 0:rueck_zeile = FELDHOEHE-1;rueck_spalte = 0;break;
						case 1:rueck_zeile = FELDHOEHE-1;rueck_spalte = FELDBREITE-1;break;
						case 2:rueck_zeile = 0;rueck_spalte = FELDBREITE-1;break;
						case 3:rueck_zeile = 0;rueck_spalte = 0;break;
					}
				}
				
				// altes Feld speichern, damit es spter animiert werden kann
				for (short i=0;i<FELDBREITE;i++)
					for(short j=0;j<FELDHOEHE;j++)
						altes_feld[i][j]=feld[i][j];
			
				// gibt es punkte fr den Click
				int p=feld_test(feldx,feldy,farbe,true);
				if(0<p)
				{
					// Punkte speichern
					if ((anz_farben-schwierigkeit)>0)
						punkte+=p*(anz_farben-schwierigkeit-1);
					// Animation (Verschwinden der Blle)
					animation();
				
					// Nachrcken des Feldes
					feld_nachruecken();
				}
				else
				{
					punkte-=punkteabzug+punkteabzug;
					if (punkte<0) ende();
				}

			} 
			else
			{
				punkte-=punkteabzug+punkteabzug;
				if (punkte<0) ende();
			}

		} // endif (click in feld

		// Spiel ende?
		if (noch_moeglich()==0) nextlevel();
		break;

	case SPIEL_ENDE:
		if(xyinrect(x,y,&rectWeiter))
		{
			if (gesamtpunkte > pScore->getMin())
				status = HIGHSCORE_AENDERN;
			else
				status = HIGHSCORE_ANZEIGEN;
		}
		break;

	case HIGHSCORE_ANZEIGEN:
		break;

	case HIGHSCORE_AENDERN:
		if(xyinrect(x,y,&rectWeiter))
			if (spielername.size()>0)
			{
				string schw="";
				switch (schwierigkeit)
				{
				case 0: schw=" (L)"; break;
				case 1: schw=" (M)"; break;
				case 2: schw=" (S)"; break;
				}

				pScore->addName(spielername+schw,gesamtpunkte);
				status=HIGHSCORE_ANZEIGEN;
			}
		break;

	case SPIEL_PAUSE:
		startzeit=SDL_GetTicks();
		status=SPIEL_LAEUFT;
		break;
	}
}
