#include "ClickVar4.h"

//////////////////////////////////////////////////////////////////////////////
//				ClickVar4 - FallDown Click									//
//////////////////////////////////////////////////////////////////////////////
// Beschreibung: Die Oberste Reihe des Feldes wird stndig mit Steinen		//
//				 gefllt. Wenn die Reihe voll ist, fallen dies auf das		//
//				 Darunterliegende Feld.										//
//				 Sollte beim Fllen ein Feld vorher belegt sein,			//
//				 ist das Spiel verloren.									//
//				 Wenn es keine Mglichkeit mehr gibt, Erfolgt ein Level-	//
//				 wechsel. Nach viel Leveln hat man Gewonnen.				//
//////////////////////////////////////////////////////////////////////////////

ClickVar4::ClickVar4()
{

	// Mit wieviel farben anfangen?
	anz_farben=4;
	
	// nachrueck-position auf links unten setzten
	rueck_zeile = FELDHOEHE-1;
	rueck_spalte= short(FELDBREITE/2);

	// Pointer zur Highscore liste
	pScore = new CHighscore("FallDown Click","Data/var4.hsc");

	// spiel starten
	start();
}

ClickVar4::~ClickVar4()
{
	
}

void ClickVar4::start()
{
	short i,j;

	// feld zufllig fllen
	for (i=0;i<FELDBREITE;i++)
	{
		// ersten drei reihen leer
		feld[i][0]=feld[i][1]=feld[i][2]=0;
		//die anderen zufllig fllen
		for(j=3;j<FELDHOEHE;j++)
			feld[i][j]=short(1+rand()%anz_farben);
	}
	
	endzeit=startzeit=0;
	anzahl_clicks=punkte=fuell_spalte=0;
	zeit=0;
	gewonnen=false;

	status=SPIEL_LAEUFT;
}

void ClickVar4::ende()
{
	// timer beenden
	endzeit=SDL_GetTicks();

	// verstrichene zeit
	zeit+= (endzeit-startzeit)/1000;

	// ergebniss berechnen
	gesamtpunkte = zeit + (anz_farben-3)*200 + punkte;
	if (gewonnen) gesamtpunkte+=3000;

	// Spiel beenden
	status=SPIEL_ENDE;
	
	// neu zeichnen
	SDL_PushEvent(&paint_event);
}

void ClickVar4::tick()
{
	static SDL_Rect rectOben={0,0,SCREEN_BREITE,32};

	if ((startzeit>0)&&(endzeit==0))
	{
		if(fuell_spalte==FELDBREITE)
		{
			// Die Standartfunktion zum nachrcken benutzen,
			// damit die oberen Steine auch nachrcken
			ClickMain::feld_nachruecken();
			fuell_spalte=0;

			// neu zeichnen
			SDL_PushEvent(&paint_event);
		}
		else if (feld[fuell_spalte][0]>0)
			ende();
		else
		{
			feld[fuell_spalte][0]=short(1+rand()%anz_farben);
			fuell_spalte++;
			// neu zeichnen
			SDL_PushEvent(&paint_event);	
		}
	}
}

void ClickVar4::pause()
{
	endzeit=SDL_GetTicks();
	zeit+=(endzeit-startzeit)/1000;
	endzeit=startzeit=0;
	status=SPIEL_PAUSE;
}

void ClickVar4::nextlevel()
{
	// eine farbe mehr
	anz_farben++;

	// position zum fllen der obersten reihe wieder auf 0 setzen
	fuell_spalte=0;

	if (anz_farben>7)
	{
		gewonnen=true;
		ende();
	}
	else
	{
		// feld zufllig fllen
		for (short i=0;i<FELDBREITE;i++)
		{
			// ersten drei reihen leer
			feld[i][0]=feld[i][1]=feld[i][2]=0;
			//die anderen zufllig fllen
			for(short j=3;j<FELDHOEHE;j++)
				feld[i][j]=short(1+rand()%anz_farben);
		}

		// neu zeichnen
		SDL_PushEvent(&paint_event);
	}
}

void ClickVar4::zeichnen()
{
	short i;
	string zeile[9];

	// obere Position des Textes
	switch (status)
	{
	// Elemente des Spiels Anzeigen
	case SPIEL_LAEUFT:
		// Feld zeichnen
		feld_zeichnen();

		// Text fr Spiel zeichnen
		text_zeichnen("Punkte: " + IntToStr(punkte),0,FELDHOEHE*32,0);
		text_zeichnen("(pause)",0,FELDHOEHE*32,1,18,&rectPause);
		text_zeichnen("Mglichkeiten: " + IntToStr(noch_moeglich()),0,FELDHOEHE*32,2);

		break;

	// Endergebniss des Spiels anzeigen
	case SPIEL_ENDE:
		if (gewonnen)
		{
			zeile[0]="Gewonnen!";
			zeile[7]="-> GewinnBonus: 3000";
		}
		else
			zeile[0]="Leider Verloren!";

		zeile[1] = "Endeergebniss des Spiels";
		zeile[2] = "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~";
		zeile[3] = "Punkte: " + IntToStr(punkte);
		zeile[4] = "Zeit: " + IntToStr(zeit) + " Sekunden";
		zeile[5] = "Farben: " + IntToStr(anz_farben);
		zeile[6] = "-> Bonus: " + IntToStr((anz_farben-3)*1000);
		zeile[8] = "-------------------------------------";
		zeile[9] = "Gesamtergebniss: " + IntToStr(gesamtpunkte);


		text_zeichnen(zeile[0],0,10,1,35);
		for(i=1;i<10;i++)
			text_zeichnen(zeile[i],0,50+i*25,1);

		text_zeichnen("weiter",0,FELDHOEHE*32,1,18,&rectWeiter);

		break;

	case HIGHSCORE_ANZEIGEN:
		highscore_anzeigen(pScore);
		break;

	case HIGHSCORE_AENDERN:
		highscore_aendern_anzeigen();
		text_zeichnen("weiter",0,FELDHOEHE*32,1,18,&rectWeiter);
		break;
	case SPIEL_PAUSE:
		text_zeichnen(" P A U S E ! ",0,SCREEN_HOEHE/3,1,90);
		break;
	}
}


void ClickVar4::feld_click(short x, short y)
{
	short feldx = x/32;
	short feldy = y/32;
	
	switch (status)
	{
	case SPIEL_LAEUFT:
		if (xyinrect(x,y,&rectPause))
		{
			pause();
			break;
		}

		if ((feldx<FELDBREITE)&&(feldy<FELDHOEHE))
		{	
			short farbe = feld[feldx][feldy];

			if (farbe>0)
			{
				// Beim ersten Clicken die Stoppuhr und Timer starten
				if (startzeit==0)
					startzeit=SDL_GetTicks();

				// Clicks erhhen
				anzahl_clicks++;
				
				// altes Feld speichern, damit es spter animiert werden kann
				for (short i=0;i<FELDBREITE;i++)
					for(short j=0;j<FELDHOEHE;j++)
						altes_feld[i][j]=feld[i][j];
			
				// gibt es punkte fr den Click
				int p=feld_test(feldx,feldy,farbe,true);
				if(0<p)
				{
					// Punkte speichern
					punkte+=p;
					// Animation (Verschwinden der Blle)
					animation();
				
					// Nachrcken des Feldes
					feld_nachruecken();
				}
				else
				{
					tick();
				}
			}
			else
			{
				tick();
			}

		} // endif (click in feld)

		// Spiel ende?
		if (noch_moeglich()==0) nextlevel();
		break;

	case SPIEL_ENDE:
		if(xyinrect(x,y,&rectWeiter))
		{
			if (gesamtpunkte > pScore->getMin())
				status = HIGHSCORE_AENDERN;
			else
				status = HIGHSCORE_ANZEIGEN;
		}
		break;

	case HIGHSCORE_ANZEIGEN:
		break;

	case HIGHSCORE_AENDERN:
		if(xyinrect(x,y,&rectWeiter))
			if (spielername.size()>0)
			{
				pScore->addName(spielername,gesamtpunkte);
				status=HIGHSCORE_ANZEIGEN;
			}
		break;

	case SPIEL_PAUSE:
		startzeit=SDL_GetTicks();
		status=SPIEL_LAEUFT;
		break;

	}
}

///////////////////////////////////////////////////////////////////////
// berladene Main-Funktionen
///////////////////////////////////////////////////////////////////////
void ClickVar4::feld_nachruecken()
{
	short i,j,b,h,grenze;

	// von oben nach "zeile"
	for (j=0;j<FELDBREITE;j++)
	{
		if(j<fuell_spalte)
			grenze=1;
		else 
			grenze=0;

		for (i=rueck_zeile;i>=grenze;i--)
			if (feld[j][i]==0)
				for (h=i-1;h>=grenze;h--)
					if (feld[j][h]>0)
					{
						feld[j][i]=feld[j][h];
						feld[j][h]=0;
						break;
					}
	}

	// von links und dann von rechts nach "spalte"
	for (j=rueck_spalte;j>=0;j--)
		if (feld[j][rueck_zeile]==0)
			for (b=j-1;b>=0;b--)
				if (feld[b][rueck_zeile]>0)
				{
					for (i=1;i<FELDHOEHE;i++)
					{
						feld[j][i]=feld[b][i];
						feld[b][i]=0;
					}
					break;
				}

	for (j=rueck_spalte;j<FELDBREITE;j++)
		if (feld[j][rueck_zeile]==0)
			for (b=j+1;b<FELDBREITE;b++)
				if (feld[b][rueck_zeile]>0)
				{
					for (i=1;i<FELDHOEHE;i++)
					{
						feld[j][i]=feld[b][i];
						feld[b][i]=0;
					}
					break;
				}
}

int ClickVar4::noch_moeglich()
{
	int moeglichkeiten=0;
	short c;
	bool test=false;

	for (short x=0;x<FELDBREITE;x++)
		for(short y=1;y<FELDHOEHE;y++)
		{
			c=feld[x][y];
			test=false;
			if (c>0)
			{
				// links testen
				if (x>0) if (feld[x-1][y]==c) test=true;

				// oben testen
				if (y>0) if (feld[x][y-1]==c) test=true;

				// rechts testen
				if (x<FELDBREITE-1) if (feld[x+1][y]==c) test=true;

				// unten testen
				if (y<FELDHOEHE-1) if (feld[x][y+1]==c) test=true;
			}
			if (test) moeglichkeiten++;
		}
	return moeglichkeiten;
}