#include "audio.h"

struct strAudio
	{
		SDL_AudioSpec spec;
		Uint8   *sound;    /* Zeiger auf die Audiodaten */
		Uint32   soundlen; /* Lnge der Audiodaten */
		int      soundpos; /* Aktuelle Abspielposition */
	} wave;

/* folgende Funktion wird aufgerufen, wenn die 
   Audiohardware weitere Daten bentigt */
void fillerup(void *unused, Uint8 *stream, int len)
{
	Uint8 *waveptr;
	int waveleft;

	// Zeiger setzten
	waveptr = wave.sound + wave.soundpos;
	waveleft = wave.soundlen - wave.soundpos;

	// Abspielen
	while ( waveleft <= len )
	{
		SDL_MixAudio(stream, waveptr, waveleft, SDL_MIX_MAXVOLUME);
		stream += waveleft;
		len -= waveleft;
		waveptr = wave.sound;
		waveleft = wave.soundlen;
		wave.soundpos = 0;
	}
	SDL_MixAudio(stream, waveptr, len, SDL_MIX_MAXVOLUME);
	wave.soundpos += len;
}

/******************************\
** Konstruktor und Destruktor **
\******************************/
CAudio::CAudio()
{
	status=false;
	wave.sound=0;
}

CAudio::CAudio(string name)
{
	status=false;
	wave.sound=0;
	lade(name);
}

CAudio::~CAudio()
{
	// Wenn eine wave-datei gffnen wurde, den speicher wieder freigeben
	if (wave.sound>0)
	{
		stop();
		SDL_FreeWAV(wave.sound);
	}
}

/********************************************************\
** Public Funktionen zum laden, wiedergeben und stoppen **
\********************************************************/
void CAudio::play()
{
	if (wave.sound>0)
	{
		status=true;
		// Audio Device ffnen
		SDL_OpenAudio(&wave.spec, NULL);

		// Start der wiedergabe
		SDL_PauseAudio(0);
	}
	else
		fprintf(stderr,"Keine Audio-Datei geffnet!");
}

void CAudio::stop()
{
	if (wave.sound>0)
	{
		status=false;
		// Wiedergabe stoppen
		SDL_PauseAudio(1);
		wave.soundpos=0;
		//Audiodevice wieder freigeben
		SDL_CloseAudio();
	}
	else
		fprintf(stderr,"Keine Audio-Datei geffnet!");
}

void CAudio::lade(string name)
{
	if (wave.sound==0)
	{
		// lade die Audiodatei
		SDL_LoadWAV(name.c_str(), &wave.spec, &wave.sound, &wave.soundlen);

		// SDL mitteilen, welche Funktion immer wieder aufgerufen werden soll
		wave.spec.callback=fillerup;
	}
	else
		fprintf(stderr,"Es ist bereits eine Audio-Datei geffnet!");
}
