#include <stdlib.h>
#include <stdio.h>
#include <sdl.h>

#include "ClickMix.h"

bool running;
int main(int argc, char **argv)
{
	if (SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO)<0)		// Initialiserung von SDL
	{
		fprintf(stderr,"SDL konnte nicht initialisiert werden: %s\n",SDL_GetError());
		exit(1);
	}

	if(TTF_Init()==-1) // Initialiserung von TTF
	{
		fprintf(stderr,"SDL_ttf konnte nicht initialisiert werden: %s\n", TTF_GetError());
		exit(1);
	}
	
	// Titel und Icon setzten
	SDL_WM_SetCaption("ClickMix","ClickMix");
	SDL_WM_SetIcon(SDL_LoadBMP("Data/icon.bmp"), NULL);

	// Unicode einschalten
	SDL_EnableUNICODE(1);

	// Game initiierne und starten
	ClickMix game;

	// Programmlogik (Eventbehandlung)
	running = true;
	while (running)
	{
		SDL_Event event;
		while(SDL_PollEvent(&event))
		{
			switch(event.type)
			{
			case SDL_KEYDOWN:
				if (event.key.keysym.sym==SDLK_ESCAPE)
					running=false;
				else
					game.press(event.key.keysym.unicode);
				break;

			case SDL_MOUSEBUTTONDOWN:
				if (event.button.button == SDL_BUTTON_LEFT)
					game.click(event.button.x, event.button.y);
				break;

			case SDL_QUIT:
				running = false;
				break;

			case SDL_USEREVENT:
				game.zeichnen();
				break;
			}
		}

		// Nach einer 1/2 Sekunde game.tick ausfhren
		static Uint32 starttime=SDL_GetTicks();
		if((SDL_GetTicks()-starttime)>=500)
		{
			game.tick();
			starttime=SDL_GetTicks();
		}
	}

	// TTF beenden
	TTF_Quit();

	// SDL beenden
	SDL_Quit();
	return 0;
}
